$MODID51
$IC(MACROS51)

	SELECT	NONE
	COMMAND	#0FH
	COMMAND	#38H
	COMMAND	#01H
	COMMAND	#80H

	DISPCH  #'A'
	DISPCH  #'m'
	DISPCH  #'p'
	DISPCH  #'l'
	DISPCH  #':'
	COMMAND	#14H

	MCALL	GetNumber
	MOV     7, 4
	COMMAND #0C0H

	DISPCH  #'F'
	DISPCH  #'r'
	DISPCH  #'e'
	DISPCH  #'q'
	DISPCH  #'u'
	DISPCH  #'e'
	DISPCH  #'n'
	DISPCH  #'c'
	DISPCH  #'y'
	DISPCH  #':'
	COMMAND	#14H

	MCALL	GetNumber

	SELECT	PORTA
	CLRCTRL	2
	MOV	R1,#0	
	MOV	DAT, R1	
	CLRCTRL	3
	
	MOV	DPTR, #Table

AGAIN:

	MOV	A,#0
	MOVMEM	A, @A+DPTR
	MOV	R1, A
	MOV     B, R7
	DIV     AB
	MOV	DAT, A

	CJNE	R1, #105, NEXT
	MOV	DPTR, #Table

        MOV     B, R4
TEMPOL2:
        DJNZ    B, TEMPOL2

	SJMP	AGAIN1

NEXT:	INC	DPTR
        MOV     B, R4
TEMPOL1:
        DJNZ    B, TEMPOL1

AGAIN1:	SJMP	AGAIN
;----------------------------------------------------------

Table:	DB	128,150,171,191,209,225,238,247,253,255,253,247,238,225,209,191,171,150,128,106,85,65,47,31,18,9,3,1,3,9,18,31,47,65,85,105

GetNumber:

NOT_PRESSED1:
	IFKBHIT
	JNC		NOT_PRESSED1
	GETSCAN		A
	MOV		DPTR, #KeyTable
	MOVMEM		A, @A+DPTR
	DISPCH		A
	SUBB		A, #30H
	MOV		R1, A
L1:	IFKBHIT
	JC		L1

NOT_PRESSED2:
	IFKBHIT
	JNC		NOT_PRESSED2
	GETSCAN		A
	MOV		DPTR, #KeyTable
	MOVMEM		A, @A+DPTR
	DISPCH		A
	SUBB		A, #30H
	MOV		R2, A
L2:	IFKBHIT
	JC		L2

NOT_PRESSED3:
	IFKBHIT
	JNC		NOT_PRESSED3
	GETSCAN		A
	MOV		DPTR, #KeyTable
	MOVMEM		A, @A+DPTR
	DISPCH		A
	SUBB		A, #30H
	MOV		R3, A
L3:	IFKBHIT
	JC		L3

	MOV	A, R1
	MOV	B, #10
	MUL	AB
	
	ADD	A, R2
	MOV	B,#10
	MUL	AB

	ADD	A, R3
	MOV	R4,A

	RET

;----------------------------
KeyTable:	DB	'123P456U789DS0ME', 0
		

END
	
